/*  Somatic - A soma puzzle solver.
 *  Copyright (C) 2003 Marc Moerig
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include "sFOX_help.hpp"
#include "sFOX_icon.hpp"

//**************************************************************************

FXIMPLEMENT(SomaHelp,FXDialogBox,NULL,0)

//**************************************************************************

// Construct a dialog box
SomaHelp::SomaHelp(FXWindow* owner):
          FXDialogBox(owner,"About Somatic",DECOR_TITLE|DECOR_BORDER,0,0,0,0,0,0,0,0,0,0){
  
  FXIcon *openpzl=new FXGIFIcon(getApp(),fileopen); 
  FXIcon *savepzl=new FXGIFIcon(getApp(),filesaveas); 
  FXIcon *closepzl=new FXGIFIcon(getApp(),killobject); 
  FXIcon *solvepzl=new FXGIFIcon(getApp(),solvepuzzle); 
  FXIcon *resetpzl=new FXGIFIcon(getApp(),resetpuzzle);     
  FXIcon *unsolvepzl=new FXGIFIcon(getApp(),unsolvepuzzle); 
  FXIcon *helppzl=new FXGIFIcon(getApp(),helppuzzle);     
  
  FXVerticalFrame* master=new FXVerticalFrame(this,LAYOUT_FILL_X|LAYOUT_FILL_Y|FRAME_RAISED,0,0,0,0,0,0,0,0);
  FXVerticalFrame* master2=new FXVerticalFrame(master,LAYOUT_FILL_X|LAYOUT_FILL_Y,0,0,0,0,5,5,5,5);
  FXVerticalFrame *upper=new FXVerticalFrame(master2,FRAME_SUNKEN|FRAME_THICK|LAYOUT_FILL_X|LAYOUT_FILL_Y,0,0,0,0,2,2,2,2);
  FXMatrix* middle=new FXMatrix(master2,7,FRAME_SUNKEN|FRAME_THICK|LAYOUT_FILL_X|LAYOUT_FILL_Y,0,0,0,0,2,2,2,2);
  FXVerticalFrame *lower=new FXVerticalFrame(master2,LAYOUT_FILL_X|LAYOUT_FILL_Y,0,0,0,0,0,0,1,0);

  // Contents
  new FXLabel(upper,"Somatic Copyright (C) 2003 Marc Moerig",NULL,JUSTIFY_CENTER_X|LAYOUT_FILL_X);
  new FXLabel(upper,"Originally created by",NULL,JUSTIFY_CENTER_X|LAYOUT_FILL_X); 
  new FXLabel(upper,"Heiko Seim, Stefan Habelski and Marc Moerig in 2002",NULL,JUSTIFY_CENTER_X|LAYOUT_FILL_X);
  new FXLabel(upper,"Please visit http://www.moerig.com/somatic/ for details.",NULL,JUSTIFY_CENTER_X|LAYOUT_FILL_X);
  new FXLabel(upper,"Somatic comes with ABSOLUTLY NO WARRANTY.",NULL,JUSTIFY_CENTER_X|LAYOUT_FILL_X);
  new FXLabel(upper,"This is free software and you are welcome to redistribute it",NULL,JUSTIFY_CENTER_X|LAYOUT_FILL_X);
  new FXLabel(upper,"under certain conditions as stated by the GPL.",NULL,JUSTIFY_CENTER_X|LAYOUT_FILL_X);  

  new FXLabel(middle,"",resetpzl,JUSTIFY_CENTER_X|LAYOUT_FILL_X); 
  new FXLabel(middle,"",solvepzl,JUSTIFY_CENTER_X|LAYOUT_FILL_X);
  new FXLabel(middle,"",unsolvepzl,JUSTIFY_CENTER_X|LAYOUT_FILL_X);
  new FXLabel(middle,"",openpzl,JUSTIFY_CENTER_X|LAYOUT_FILL_X); 
  new FXLabel(middle,"",savepzl,JUSTIFY_CENTER_X|LAYOUT_FILL_X);
  new FXLabel(middle,"",helppzl,JUSTIFY_CENTER_X|LAYOUT_FILL_X); 
  new FXLabel(middle,"",closepzl,JUSTIFY_CENTER_X|LAYOUT_FILL_X);
  new FXLabel(middle,"Start a new Puzzle. Everything will be deleted.",NULL,JUSTIFY_LEFT|JUSTIFY_CENTER_Y|LAYOUT_FILL_X|LAYOUT_CENTER_Y); 
  new FXLabel(middle,"Try to find a solution for the current puzzle.",NULL,JUSTIFY_LEFT|JUSTIFY_CENTER_Y|LAYOUT_FILL_X|LAYOUT_CENTER_Y);
  new FXLabel(middle,"Reset the solution so that you can continue construction.",NULL,JUSTIFY_LEFT|JUSTIFY_CENTER_Y|LAYOUT_FILL_X|LAYOUT_CENTER_Y);
  new FXLabel(middle,"Load an old puzzle or config file.",NULL,JUSTIFY_LEFT|JUSTIFY_CENTER_Y|LAYOUT_FILL_X|LAYOUT_CENTER_Y); 
  new FXLabel(middle,"Save current puzzle. (A solution will also be saved)",NULL,JUSTIFY_LEFT|JUSTIFY_CENTER_Y|LAYOUT_FILL_X|LAYOUT_CENTER_Y);
  new FXLabel(middle,"This help dialog.",NULL,JUSTIFY_LEFT|JUSTIFY_CENTER_Y|LAYOUT_FILL_X|LAYOUT_CENTER_Y); 
  new FXLabel(middle,"Quit the entire program.",NULL,JUSTIFY_LEFT|JUSTIFY_CENTER_Y|LAYOUT_FILL_X|LAYOUT_CENTER_Y);
  

  FXButton *bt = new FXButton(lower,"Close",NULL,this,ID_ACCEPT,FRAME_RAISED|FRAME_THICK|LAYOUT_CENTER_X|LAYOUT_FILL_X|LAYOUT_BOTTOM,0,0,0,0,2,2,2,2);
  bt->setHelpText("Close window.");
  
}

//**************************************************************************

