/*  Somatic - A soma puzzle solver.
 *  Copyright (C) 2003 Marc Moerig
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef soma_gfx_single
#define soma_gfx_single

#define HAVE_OPENGL

#include <fx.h>
#include <fx3d.h>

#include "s_problem.hpp"

#include "sGFX_generic.hpp"
#include "sGFX_cubearray.hpp"

//**************************************************************************

class SomaSingleGFX : public SomaBaseGFX{
protected:
  
  static const double zoomrange;
  static const double zoomstart;
  static const double safedist;
  
  SomaProb *const pbl;
  SomaCubeArray cubes;
  
  double w,h;
  
  SomaMatrix rotation;
  double dist;

  /* draw this object using ogl */
  virtual void display(const GLenum mode)=0;
    
public:

  // constructor
  SomaSingleGFX(SomaProb *const p);
  
  // constructor
  SomaSingleGFX(SomaProb *const p,const SomaSingleGFX *const other);
  
  // destructor
  virtual ~SomaSingleGFX();
  
  /* notify object that the space for drawing has changed */
  void resize(const unsigned int width,const unsigned int height);
  
  /* draw the object */
  void draw();

  /** notify the object of a mouseclick */
  virtual void mouseClick(const unsigned int x,const unsigned int y,
                          const MOUSEBUTTON button)=0;
 
  /** notify the object of a mousemove */
  virtual void mouseMove(const int deltax,const int deltay,
                         const MOUSEBUTTON button)=0;
};

//**************************************************************************

#endif
